package com.edgec.browserbackend.common.utils;

import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.springframework.util.StringUtils;

import javax.crypto.*;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.SecretKeySpec;
import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.Security;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.util.Base64;

public class EncodeUtil {

    public void decodeBase64() {
        System.out.println(Base64.getDecoder().decode("G65nlqVr9c7ZBUN/uEG136nZ/a1lneIHbQ3sY8Cj5SA="));

    }

    public void encodeBase64() throws NoSuchPaddingException, NoSuchAlgorithmException, NoSuchProviderException, UnsupportedEncodingException, InvalidKeySpecException, InvalidKeyException, BadPaddingException, IllegalBlockSizeException {
        byte[] byteContent = new byte[0];
        byteContent = "b3LcaXzXzf4Z6GzB6q2KyMP5RC1pF6".getBytes("utf-8");
        byte[] salt = new byte[]{
                0x47, 0x8, 0x0e, 0x0b, 0x02, 0x0f, 0x0b, 0x0c,
                0x01, 0x03, 0x12, 0x07, 0x0c, 0x02, 0x07, 0x09,
                0x0a, 0x0a, 0x01, 0x07, 0x0b, 0x07, 0x09, 0x0d};
        SecretKeyFactory factory = null;
        factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA256");
        char[] passphrase = (StringUtils.isEmpty(System.getenv("INTELLIGROUP_PHRASE")) ?
                "ACtrecje!@9cs93cdeMMdkc" : System.getenv("INTELLIGROUP_PHRASE")).toCharArray();
        KeySpec spec = new PBEKeySpec(passphrase, salt, 65536, 256);
        SecretKey tmp = null;
        tmp = factory.generateSecret(spec);
        SecretKeySpec secret = new SecretKeySpec(tmp.getEncoded(), "AES");
        Security.addProvider(new BouncyCastleProvider());
        Cipher encryptor = null;
        encryptor = Cipher.getInstance("AES/ECB/PKCS7Padding", "BC");
        encryptor.init(Cipher.ENCRYPT_MODE, secret);
        byte[] cryptograph = new byte[0];

        cryptograph = encryptor.doFinal(byteContent);
        String encryptedKeyId = Base64.getEncoder().encodeToString(cryptograph);
        System.out.println(encryptedKeyId);
    }
}
